Index: trunk/examples/objects/number/number.cc
===================================================================
--- trunk/examples/objects/number/number.cc	(revision 1569)
+++ trunk/examples/objects/number/number.cc	(revision 1581)
@@ -1,10 +1,5 @@
 #include <iostream>
-#include <errno.h>
-#include <fstream>
-#include <sys/stat.h>
 #include "RpNumber.h"
-
-size_t indent = 0;
-size_t tabstop = 4;
+#include "RpTest.h"
 
 int
@@ -24,84 +19,4 @@
 }
 
-int testStringVal(
-    const char *testname,
-    const char *desc,
-    const char *expected,
-    const char *received)
-{
-    if ((!expected && received) ||
-        (expected && !received) ||
-        (expected && received && strcmp(expected,received) != 0)) {
-        printf("Error: %s\n", testname);
-        printf("\t%s\n", desc);
-        printf("\texpected \"%s\"\n",expected);
-        printf("\treceived \"%s\"\n",received);
-        return 1;
-    }
-    return 0;
-}
-
-int testDoubleVal(
-    const char *testname,
-    const char *desc,
-    double expected,
-    double received)
-{
-    if (expected != received) {
-        printf("Error: %s\n", testname);
-        printf("\t%s\n", desc);
-        printf("\texpected \"%g\"\n",expected);
-        printf("\treceived \"%g\"\n",received);
-        return 1;
-    }
-    return 0;
-}
-
-size_t
-readFile (
-    const char *filePath,
-    const char **buf)
-{
-    if (buf == NULL) {
-        fprintf(stderr,"buf is NULL while opening file \"%s\"", filePath);
-        return 0;
-    }
-
-    FILE *f;
-    f = fopen(filePath, "rb");
-    if (f == NULL) {
-        fprintf(stderr,"can't open \"%s\": %s", filePath, strerror(errno));
-        return 0;
-    }
-    struct stat stat;
-    if (fstat(fileno(f), &stat) < 0) {
-        fprintf(stderr,"can't stat \"%s\": %s", filePath, strerror(errno));
-        return 0;
-    }
-    off_t size;
-    size = stat.st_size;
-    char* memblock;
-    memblock = new char [size+1];
-    if (memblock == NULL) {
-        fprintf(stderr,"can't allocate %zu bytes for file \"%s\": %s",
-            (size_t)size, filePath, strerror(errno));
-        fclose(f);
-        return 0;
-    }
-
-    size_t nRead;
-    nRead = fread(memblock, sizeof(char), size, f);
-    fclose(f);
-
-    if (nRead != (size_t)size) {
-        fprintf(stderr,"can't read %zu bytes from \"%s\": %s",
-            (size_t) size, filePath, strerror(errno));
-        return 0;
-    }
-
-    memblock[size] = '\0';
-    *buf = memblock;
-    return nRead;
-}
 int number_0_0 ()
 {
@@ -180,16 +95,377 @@
     const char *testdesc = "test constructing number from xml";
     const char *testname = "number_1_0";
-    const char *filePath = "number_1_0_in.xml";
-    int retVal = 0;
-
-    const char *buf = NULL;
-    readFile(filePath,&buf);
-
-    const char *name = "Ef";
-    const char *units = "eV";
-    double def = 0;
-    double cur = 5;
-    double min = -10;
-    double max = 10;
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <units>eV</units>\
+    <min>-10eV</min>\
+    <max>10eV</max>\
+    <default>0eV</default>\
+    <current>5eV</current>\
+    <preset>\
+        <value>300K</value>\
+        <label>300K (room temperature)</label>\
+    </preset>\
+    <preset>\
+        <value>77K</value>\
+        <label>77K (liquid nitrogen)</label>\
+    </preset>\
+    <preset>\
+        <value>4.2K</value>\
+        <label>4.2K (liquid helium)</label>\
+    </preset>\
+</number>";
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_1 ()
+{
+    const char *testdesc = "test constructing number from xml, no min";
+    const char *testname = "number_1_1";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <units>eV</units>\
+    <max>10eV</max>\
+    <default>0eV</default>\
+    <current>5eV</current>\
+</number>";
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_2 ()
+{
+    const char *testdesc = "test constructing number from xml, no max";
+    const char *testname = "number_1_2";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <units>eV</units>\
+    <min>-10eV</min>\
+    <default>0eV</default>\
+    <current>5eV</current>\
+</number>";
+
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_3 ()
+{
+    const char *testdesc = "test constructing number from xml, no min, no max";
+    const char *testname = "number_1_3";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <units>eV</units>\
+    <default>0eV</default>\
+    <current>5eV</current>\
+</number>";
+
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_4 ()
+{
+    const char *testdesc = "test constructing number from xml, no cur";
+    const char *testname = "number_1_4";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <units>eV</units>\
+    <min>-10eV</min>\
+    <max>10eV</max>\
+    <default>0eV</default>\
+</number>";
+
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 0;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    // if no current value is provided it defaults to 0.0.
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_5 ()
+{
+    const char *testdesc = "test constructing number from xml, no def";
+    const char *testname = "number_1_5";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <units>eV</units>\
+    <min>-10eV</min>\
+    <max>10eV</max>\
+    <current>5eV</current>\
+</number>";
+
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    // if no default value is provided it defaults to 0.0.
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_6 ()
+{
+    const char *testdesc = "test constructing number from xml, no def, no cur";
+    const char *testname = "number_1_6";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <units>eV</units>\
+    <min>-10eV</min>\
+    <max>10eV</max>\
+</number>";
+
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 0;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_7 ()
+{
+    const char *testdesc = "test constructing number from xml, no def cur min max";
+    const char *testname = "number_1_7";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <units>eV</units>\
+</number>";
+
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 0;
+    double min = 0;
+    double max = 0;
     const char *label = "Fermi Level";
     const char *desc = "Energy at center of distribution.";
@@ -210,4 +486,413 @@
     return retVal;
 }
+
+int number_1_8 ()
+{
+    const char *testdesc = "test constructing number from xml, no explicit units";
+    const char *testname = "number_1_8";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <min>-10eV</min>\
+    <max>10eV</max>\
+    <default>0eV</default>\
+    <current>5eV</current>\
+</number>";
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    // units are implied from min, max, def, cur values
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_9 ()
+{
+    const char *testdesc = "test constructing number from xml, no description";
+    const char *testname = "number_1_9";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+    </about>\
+    <units>eV</units>\
+    <min>-10eV</min>\
+    <max>10eV</max>\
+    <default>0eV</default>\
+    <current>5eV</current>\
+</number>";
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_10 ()
+{
+    const char *testdesc = "test constructing number from xml, no label";
+    const char *testname = "number_1_10";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <units>eV</units>\
+    <min>-10eV</min>\
+    <max>10eV</max>\
+    <default>0eV</default>\
+    <current>5eV</current>\
+</number>";
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_11 ()
+{
+    const char *testdesc = "test constructing number from xml, no label description";
+    const char *testname = "number_1_11";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+    </about>\
+    <units>eV</units>\
+    <min>-10eV</min>\
+    <max>10eV</max>\
+    <default>0eV</default>\
+    <current>5eV</current>\
+</number>";
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "";
+    const char *desc = "";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    // if no default value and no current value is provided
+    // both default to 0.0.
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_12 ()
+{
+    const char *testdesc = "test constructing number from xml, no about label description";
+    const char *testname = "number_1_12";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <units>eV</units>\
+    <min>-10eV</min>\
+    <max>10eV</max>\
+    <default>0eV</default>\
+    <current>5eV</current>\
+</number>";
+
+    const char *name = "Ef";
+    const char *units = "eV";
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "";
+    const char *desc = "";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    // if no default value and no current value is provided
+    // both default to 0.0.
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_13 ()
+{
+    const char *testdesc = "test constructing number from xml, no def cur min max units";
+    const char *testname = "number_1_13";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+</number>";
+
+
+    const char *name = "Ef";
+    const char *units = NULL;
+    double def = 0;
+    double cur = 0;
+    double min = 0;
+    double max = 0;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    // if no default value and no current value is provided
+    // both default to 0.0.
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_14 ()
+{
+    const char *testdesc = "test constructing number from xml, only name";
+    const char *testname = "number_1_14";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+</number>";
+
+
+    const char *name = "Ef";
+    const char *units = NULL;
+    double def = 0;
+    double cur = 0;
+    double min = 0;
+    double max = 0;
+    const char *label = "";
+    const char *desc = "";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_15 ()
+{
+    const char *testdesc = "test constructing number from xml, no info";
+    const char *testname = "number_1_15";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number>\
+</number>";
+
+
+    const char *name = "";
+    const char *units = NULL;
+    double def = 0;
+    double cur = 0;
+    double min = 0;
+    double max = 0;
+    const char *label = "";
+    const char *desc = "";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+int number_1_16 ()
+{
+    const char *testdesc = "test constructing number from xml, no explicit or implied units";
+    const char *testname = "number_1_16";
+    int retVal = 0;
+
+    const char *buf =
+"<?xml version=\"1.0\"?>\
+<number id=\"Ef\">\
+    <about>\
+        <label>Fermi Level</label>\
+        <description>Energy at center of distribution.</description>\
+    </about>\
+    <min>-10</min>\
+    <max>10</max>\
+    <default>0</default>\
+    <current>5</current>\
+</number>";
+
+    const char *name = "Ef";
+    const char *units = NULL;
+    double def = 0;
+    double cur = 5;
+    double min = -10;
+    double max = 10;
+    const char *label = "Fermi Level";
+    const char *desc = "Energy at center of distribution.";
+
+    Rappture::Number n;
+
+    n.configure(Rappture::RPCONFIG_XML,(void*)buf);
+
+    retVal |= testStringVal(testname,testdesc,name,n.name());
+    retVal |= testStringVal(testname,testdesc,units,n.units());
+    retVal |= testDoubleVal(testname,testdesc,def,n.def());
+    retVal |= testDoubleVal(testname,testdesc,cur,n.cur());
+    if (n.minset()) {
+        retVal |= testDoubleVal(testname,testdesc,min,n.min());
+    }
+    if (n.maxset()) {
+        retVal |= testDoubleVal(testname,testdesc,max,n.max());
+    }
+    retVal |= testStringVal(testname,testdesc,label,n.label());
+    retVal |= testStringVal(testname,testdesc,desc,n.desc());
+
+    return retVal;
+}
+
+// FIXME: more tests:
+// what if units in min, max, def, cur differ from units()
+// what if you can't convert from units in min, max, def, cur to units()
+// what if units in presets differ from units()
+// test case for value() function when only cur was configured
+// test case for value() function when only def was configured
+// test case for vvalue() function with no hints
+// test case for vvalue() function with "units=" hint
+// test case for setting up object, what is cur when only def is provided
+// test case for setting up object, what is def when only cur is provided
 
 int main()
@@ -216,4 +901,20 @@
     number_0_1();
     number_1_0();
+    number_1_1();
+    number_1_2();
+    number_1_3();
+    number_1_4();
+    number_1_5();
+    number_1_6();
+    number_1_7();
+    number_1_8();
+    number_1_9();
+    number_1_10();
+    number_1_11();
+    number_1_12();
+    number_1_13();
+    number_1_14();
+    number_1_15();
+    number_1_16();
 
     return 0;
Index: trunk/examples/objects/path/path.cc
===================================================================
--- trunk/examples/objects/path/path.cc	(revision 1569)
+++ trunk/examples/objects/path/path.cc	(revision 1581)
@@ -782,4 +782,5 @@
 //        input.number2(eee)
 //        input.number(eee)2
+// FIXME: add test for _ifs inside of id tags
 
 int main()
Index: trunk/examples/objects/plot/plot.cc
===================================================================
--- trunk/examples/objects/plot/plot.cc	(revision 1569)
+++ trunk/examples/objects/plot/plot.cc	(revision 1581)
@@ -154,8 +154,9 @@
     std::printf("curveCnt = %zu\n",curveCnt);
 
-    size_t indent = 0;
-    size_t tabstop = 4;
-
-    std::printf("xml: %s\n",p1->xml(indent,tabstop));
+    Rappture::ClientDataXml d;
+    d.indent = 0;
+    d.tabstop = 4;
+    p1->dump(Rappture::RPCONFIG_XML,&d);
+    std::printf("xml: %s\n",d.retStr);
 
     delete p1;
Index: trunk/examples/objects/xmlparser/xmlparser.cc
===================================================================
--- trunk/examples/objects/xmlparser/xmlparser.cc	(revision 1569)
+++ trunk/examples/objects/xmlparser/xmlparser.cc	(revision 1581)
@@ -32,5 +32,5 @@
     if (memblock == NULL) {
         fprintf(stderr,"can't allocate %zu bytes for file \"%s\": %s",
-            size, filePath, strerror(errno));
+            (size_t) size, filePath, strerror(errno));
         fclose(f);
         return 0;
@@ -42,5 +42,5 @@
 
     if (nRead != (size_t)size) {
-        fprintf(stderr,"can't read %zu bytes from \"%s\": %s", size, filePath,
+        fprintf(stderr,"can't read %zu bytes from \"%s\": %s", (size_t) size, filePath,
             strerror(errno));
         return 0;
@@ -86,4 +86,45 @@
     const char *infile = "xmlparser_1_0_in.xml";
     const char *outfile = "xmlparser_1_0_out.xml";
+    int retVal = 0;
+
+    const char *xmltext = NULL;
+    const char *expected = NULL;
+
+    readFile(infile,&xmltext);
+    readFile(outfile,&expected);
+
+    const char *received = NULL;
+
+    Rp_ParserXml *p = NULL;
+
+    p = Rp_ParserXmlCreate();
+
+    Rp_ParserXmlParse(p, xmltext);
+
+    received = Rp_ParserXmlXml(p);
+
+
+    if (strcmp(expected,received) != 0) {
+        printf("Error: %s\n", testname);
+        printf("\t%s\n", desc);
+        printf("\texpected %zu bytes: \"%s\"\n",strlen(expected), expected);
+        printf("\treceived %zu bytes: \"%s\"\n",strlen(received), received);
+        retVal = 1;
+    }
+
+    if (p) {
+        Rp_ParserXmlDestroy(&p);
+    }
+
+    return retVal;
+}
+
+
+int xmlparser_1_1 ()
+{
+    const char *desc = "test sending xml text to xml parser";
+    const char *testname = "xmlparser_1_1";
+    const char *infile = "xmlparser_1_1_in.xml";
+    const char *outfile = "xmlparser_1_1_out.xml";
     int retVal = 0;
 
@@ -313,4 +354,5 @@
     xmlparser_0_0();
     xmlparser_1_0();
+    xmlparser_1_1();
     xmlparser_2_0();
     xmlparser_3_0();
